﻿@page "/"
@inject HttpClient http

<MudContainer>
	<MudGrid Class="d-flex flex-wrap">
		<MudItem xs="12">
			<MudPaper Class="d-flex align-center justify-center mud-width-full py-8 flex-column">
				<MudText Typo="Typo.h6">Energy Usage Today</MudText>
				<MudChart ChartType="ChartType.Line" ChartSeries="@_series" ChartOptions="@_options" XAxisLabels="@_xAxisLabels" Width="100%" Height="100%" Style="height: 35vh;"  />
			</MudPaper>
		</MudItem>

		<MudItem xs="4" Style="min-width: 325px; align-self: center; margin: auto;">
			<MudLink Href="/calendar">
				<MudPaper Class="d-flex align-center justify-center mud-width-full py-8 flex-column">
					<MudIcon Icon="@Icons.Material.Filled.CalendarMonth" Color="Color.Inherit" />
					<MudText Typo="Typo.h6" Class="ps-2">Garbage collection calendar</MudText>
				</MudPaper>
			</MudLink>
		</MudItem>

		<MudItem xs="4" Style="min-width: 325px; align-self: center; margin: auto;">
			<MudLink Href="/todo">
				<MudPaper Class="d-flex align-center justify-center mud-width-full py-8 flex-column">
					<MudIcon Icon="@Icons.Material.Filled.Assignment" Color="Color.Inherit" />
					<MudText Typo="Typo.h6" Class="ps-2">My Todolists</MudText>
				</MudPaper>
			</MudLink>
		</MudItem>

		<MudItem xs="4" Style="min-width: 325px; align-self: center; margin: auto;">
			<MudLink Href="/files">
				<MudPaper Class="d-flex align-center justify-center mud-width-full py-8 flex-column">
					<MudIcon Icon="@Icons.Material.Filled.Archive" Color="Color.Inherit" />
					<MudText Typo="Typo.h6" Class="ps-2">My Files</MudText>
				</MudPaper>
			</MudLink>
		</MudItem>
	</MudGrid>
</MudContainer>

@code {
	private List<ChartSeries> _series = new();
	private List<DoorheenDeDagVerbruik> energyUsage = new();
	private ChartOptions _options = new();
	private string[] _xAxisLabels = new string[24];

	protected override async Task OnInitializedAsync()
	{
		_options = new ChartOptions
			{
				InterpolationOption = InterpolationOption.NaturalSpline
			};
		for (int i = 0; i < 24; i++)
		{
			_xAxisLabels[i] = "";
		}
		await GetEnergyUsage();
	}

	private async Task GenerateChart()
	{
		var new_series = new List<ChartSeries>(){new ChartSeries() { Name = "Energy Usage h(Wh)", Data = new double[24] } };
		int i = 0;
		foreach (var _energyUsage in energyUsage)
		{
			new_series[0].Data[i] = (_energyUsage.TotaalVerbruik) * 1000;
			_xAxisLabels[i] = _energyUsage.Timestamp.AddHours(1).Hour.ToString();
			i++;
		}
		_series = new_series;
	}

	private async Task GetEnergyUsage()
	{
		energyUsage = await http.GetFromJsonAsync<List<DoorheenDeDagVerbruik>>($"api/energyusage");
		await GenerateChart();
		StateHasChanged();
	}
}